package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.base.entity.BasePriceStrategyDetailEnt;
import pps.core.base.entity.BasePriceStrategyDetailView;
import pps.core.base.mapper.BasePriceStrategyDetailMapper;
import pps.core.base.mapper.BasePriceStrategyDetailViewMapper;
import pps.core.base.service.data.base_price_strategy_detail.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class BasePriceStrategyDetailService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createBasePriceStrategyDetail(XContext context, CreateBasePriceStrategyDetailInput input) {
        BasePriceStrategyDetailMapper mapper = context.getBean(BasePriceStrategyDetailMapper.class);
        BasePriceStrategyDetailEnt entity = new BasePriceStrategyDetailEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateBasePriceStrategyDetail(XContext context, UpdateBasePriceStrategyDetailInput input) {
        BasePriceStrategyDetailMapper mapper = context.getBean(BasePriceStrategyDetailMapper.class);
        QueryWrapper<BasePriceStrategyDetailEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePriceStrategyDetailEnt::getId, input.getId());
        BasePriceStrategyDetailEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteBasePriceStrategyDetail(XContext context, DeleteBasePriceStrategyDetailInput input) {
        BasePriceStrategyDetailMapper mapper = context.getBean(BasePriceStrategyDetailMapper.class);
        QueryWrapper<BasePriceStrategyDetailEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePriceStrategyDetailEnt::getId, input.getId());
        BasePriceStrategyDetailEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBasePriceStrategyDetailOutput> getBasePriceStrategyDetail(XContext context, GetBasePriceStrategyDetailInput input) {
        BasePriceStrategyDetailMapper mapper = context.getBean(BasePriceStrategyDetailMapper.class);
        QueryWrapper<BasePriceStrategyDetailEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePriceStrategyDetailEnt::getId, input.getId());
        BasePriceStrategyDetailEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBasePriceStrategyDetailOutput output = new GetBasePriceStrategyDetailOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePriceStrategyDetailOutput> queryBasePriceStrategyDetail(XContext context, QueryBasePriceStrategyDetailInput input) {
        BasePriceStrategyDetailMapper mapper = context.getBean(BasePriceStrategyDetailMapper.class);
        QueryWrapper<BasePriceStrategyDetailEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(BasePriceStrategyDetailEnt::getId, input.getId())
                .eq(BasePriceStrategyDetailEnt::getIsDeleted, input.getIsDeleted())
                .like(BasePriceStrategyDetailEnt::getCreateById, input.getCreateById())
                .like(BasePriceStrategyDetailEnt::getCreateByName, input.getCreateByName())
                .eq(BasePriceStrategyDetailEnt::getCreateTime, input.getCreateTime())
                .like(BasePriceStrategyDetailEnt::getModifyById, input.getModifyById())
                .like(BasePriceStrategyDetailEnt::getModifyByName, input.getModifyByName())
                .eq(BasePriceStrategyDetailEnt::getModifyTime, input.getModifyTime())
                .like(BasePriceStrategyDetailEnt::getStrategyId, input.getStrategyId())
                .like(BasePriceStrategyDetailEnt::getStrategyMonthId, input.getStrategyMonthId())
                .like(BasePriceStrategyDetailEnt::getPeriodTypeKey, input.getPeriodTypeKey())
                .eq(BasePriceStrategyDetailEnt::getStartTime, input.getStartTime())
                .eq(BasePriceStrategyDetailEnt::getEndTime, input.getEndTime())
                .eq(BasePriceStrategyDetailEnt::getElectrovalence, input.getElectrovalence())
                .eq(BasePriceStrategyDetailEnt::getInternalSettlementPrice, input.getInternalSettlementPrice());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryBasePriceStrategyDetailOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePriceStrategyDetailOutput> dynamicQueryBasePriceStrategyDetail(XContext context, CustomQueryInput input) {
        BasePriceStrategyDetailMapper mapper = context.getBean(BasePriceStrategyDetailMapper.class);
        return XMapperHelper.query(mapper, input, BasePriceStrategyDetailEnt.class, QueryBasePriceStrategyDetailOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBasePriceStrategyDetailViewOutput> getBasePriceStrategyDetailView(XContext context, GetBasePriceStrategyDetailViewInput input) {
        BasePriceStrategyDetailViewMapper mapper = context.getBean(BasePriceStrategyDetailViewMapper.class);
        BasePriceStrategyDetailView record = new BasePriceStrategyDetailView();
        XCopyUtils.copyObject(input, record);
        BasePriceStrategyDetailView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBasePriceStrategyDetailViewOutput output = new GetBasePriceStrategyDetailViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePriceStrategyDetailViewOutput> queryBasePriceStrategyDetailView(XContext context, QueryBasePriceStrategyDetailViewInput input) {
        BasePriceStrategyDetailViewMapper mapper = context.getBean(BasePriceStrategyDetailViewMapper.class);
        BasePriceStrategyDetailView record = new BasePriceStrategyDetailView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<BasePriceStrategyDetailView> list = mapper.selectList(record);
        PageInfo<BasePriceStrategyDetailView> pageInfo = new PageInfo<>(list);
        List<QueryBasePriceStrategyDetailViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryBasePriceStrategyDetailViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
