package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.base.entity.BasePriceStrategyMonthEnt;
import pps.core.base.entity.BasePriceStrategyMonthView;
import pps.core.base.mapper.BasePriceStrategyMonthMapper;
import pps.core.base.mapper.BasePriceStrategyMonthViewMapper;
import pps.core.base.service.data.base_price_strategy_month.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class BasePriceStrategyMonthService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createBasePriceStrategyMonth(XContext context, CreateBasePriceStrategyMonthInput input) {
        BasePriceStrategyMonthMapper mapper = context.getBean(BasePriceStrategyMonthMapper.class);
        BasePriceStrategyMonthEnt entity = new BasePriceStrategyMonthEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateBasePriceStrategyMonth(XContext context, UpdateBasePriceStrategyMonthInput input) {
        BasePriceStrategyMonthMapper mapper = context.getBean(BasePriceStrategyMonthMapper.class);
        QueryWrapper<BasePriceStrategyMonthEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePriceStrategyMonthEnt::getId, input.getId());
        BasePriceStrategyMonthEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteBasePriceStrategyMonth(XContext context, DeleteBasePriceStrategyMonthInput input) {
        BasePriceStrategyMonthMapper mapper = context.getBean(BasePriceStrategyMonthMapper.class);
        QueryWrapper<BasePriceStrategyMonthEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePriceStrategyMonthEnt::getId, input.getId());
        BasePriceStrategyMonthEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBasePriceStrategyMonthOutput> getBasePriceStrategyMonth(XContext context, GetBasePriceStrategyMonthInput input) {
        BasePriceStrategyMonthMapper mapper = context.getBean(BasePriceStrategyMonthMapper.class);
        QueryWrapper<BasePriceStrategyMonthEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePriceStrategyMonthEnt::getId, input.getId());
        BasePriceStrategyMonthEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBasePriceStrategyMonthOutput output = new GetBasePriceStrategyMonthOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePriceStrategyMonthOutput> queryBasePriceStrategyMonth(XContext context, QueryBasePriceStrategyMonthInput input) {
        BasePriceStrategyMonthMapper mapper = context.getBean(BasePriceStrategyMonthMapper.class);
        QueryWrapper<BasePriceStrategyMonthEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(BasePriceStrategyMonthEnt::getId, input.getId())
                .eq(BasePriceStrategyMonthEnt::getIsDeleted, input.getIsDeleted())
                .like(BasePriceStrategyMonthEnt::getCreateById, input.getCreateById())
                .like(BasePriceStrategyMonthEnt::getCreateByName, input.getCreateByName())
                .eq(BasePriceStrategyMonthEnt::getCreateTime, input.getCreateTime())
                .like(BasePriceStrategyMonthEnt::getModifyById, input.getModifyById())
                .like(BasePriceStrategyMonthEnt::getModifyByName, input.getModifyByName())
                .eq(BasePriceStrategyMonthEnt::getModifyTime, input.getModifyTime())
                .like(BasePriceStrategyMonthEnt::getStrategyId, input.getStrategyId())
                .eq(BasePriceStrategyMonthEnt::getStrategyMonth, input.getStrategyMonth());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryBasePriceStrategyMonthOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePriceStrategyMonthOutput> dynamicQueryBasePriceStrategyMonth(XContext context, CustomQueryInput input) {
        BasePriceStrategyMonthMapper mapper = context.getBean(BasePriceStrategyMonthMapper.class);
        return XMapperHelper.query(mapper, input, BasePriceStrategyMonthEnt.class, QueryBasePriceStrategyMonthOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBasePriceStrategyMonthViewOutput> getBasePriceStrategyMonthView(XContext context, GetBasePriceStrategyMonthViewInput input) {
        BasePriceStrategyMonthViewMapper mapper = context.getBean(BasePriceStrategyMonthViewMapper.class);
        BasePriceStrategyMonthView record = new BasePriceStrategyMonthView();
        XCopyUtils.copyObject(input, record);
        BasePriceStrategyMonthView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBasePriceStrategyMonthViewOutput output = new GetBasePriceStrategyMonthViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePriceStrategyMonthViewOutput> queryBasePriceStrategyMonthView(XContext context, QueryBasePriceStrategyMonthViewInput input) {
        BasePriceStrategyMonthViewMapper mapper = context.getBean(BasePriceStrategyMonthViewMapper.class);
        BasePriceStrategyMonthView record = new BasePriceStrategyMonthView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<BasePriceStrategyMonthView> list = mapper.selectList(record);
        PageInfo<BasePriceStrategyMonthView> pageInfo = new PageInfo<>(list);
        List<QueryBasePriceStrategyMonthViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryBasePriceStrategyMonthViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
